#ifndef _GRAPHICS_H_
#define _GRAPHICS_H_

#include "types.h"
#include "fire-sparse.h"

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>

/*
 * 04.09.2000, 0.0.12
 */
typedef struct {
  int blackColor, whiteColor, thescreen;
  XTextProperty textproperty;
  Display *thedisplay;
  GC thecontext;
  Font thefont;
  XEvent anevent;
  XColor xc;
  XPoint v[3];
  Colormap thecolormap;
  Window thewindow, root;
  XImage *ximg;
  XImage *back;
  KeySym keysym;
  int xr, yr, hr, wr, br, dr;
  int x0;
  int y0;
  uint32 rmask, gmask, bmask;
  int w, h;
  uchar *image;
  uint *colors, *pal;
  char *colormapFile;
  int inRootWindow;
  int isBackground;
  Pixmap pixInfo;
  GC gcInfo;
  void (*convert)( char *, char *, uint32 *, uint32 );
  int bytesPerPixel;
  int bitsPerPixel;
  int indexed;
  int byteOrder;
} GraphicsData;

int32 initGraphics( GraphicsData *p, char *name, uint16 *w, uint16 *h );
int32 clearGraphics( GraphicsData *p );
int32 processEvents( GraphicsData *p );
int32 updateBackground( GraphicsData *gr, GridInfo *gi );
int32 insertImage( uchar *p1, GraphicsData *p2, GridInfo *gi );

void putString( int32 x, int32 y, char *text, int color, GraphicsData *p );
void putStats( int32 x, int32 y, char *s1, char *s2, GraphicsData *p );

#endif
