#include "handle.h"
#include "graphics.h"

#include <math.h>

int32 handleEvents( FSparseData *d, GraphicsData *gr,
		    FParams *par, int32 event )
{
  int w = 20, h = 20;
/*    int mask[225] = { */
/*      1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, */
/*      1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, */
/*      1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, */
/*      1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, */
/*      0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, */
/*      0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, */
/*      0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, */
/*      0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, */
/*      0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, */
/*      0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, */
/*      0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, */
/*      1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, */
/*      1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, */
/*      1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, */
/*      1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, */
/*    }; */
  int mask[400] = {
    0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,
    0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,
    0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,
    0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,
    0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
    0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
    0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
    0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
    0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
    0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,
    0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,
    0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,
    0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0
  };
  int x, y, i, j;
  int x0, y0, x1, y1, step = 10, n;
  float dx = 0.0, dy = 0.0, dl, fx, fy;
  XMotionEvent *motion;

  switch (event) {
  case EV_MOTION:
    motion = (XMotionEvent *) &gr->anevent;
/*      printf( "%d %d\n", motion->x, motion->y ); */

    x1 = motion->x;
    y1 = motion->y;
    x0 = gr->x0;
    y0 = gr->y0;
    if (gr->inRootWindow) {
      x0 = x1;
      y0 = y1;
    } else {
      dx = x1 - x0;
      dy = y1 - y0;
    }
    dl = sqrt( dx * dx + dy * dy );
    if (dl > step) {
      dx *= step / dl;
      dy *= step / dl;
      n = dl / sqrt( dx * dx + dy * dy );
    } else n = 1;

/*      printf( "%d %d %d %d %f %f %d\n", x0, y0, x1, y1, dx, dy, n ); */

    fx = x0;
    fy = y0;
    for (j = 0; j < n; j++) {
      for (i = 0; i < w * h; i++) {
	if (!mask[i]) continue;
	x = fx + (i / w ) - 10;
	y = fy + (i % w ) - 10;
	if ((x < 1) || (x >= (par->fireW - 1)) ||
	    (y < 1) || (y >= (par->fireH - 1))) continue;
	addFPixel( d->bufFP, d->listFP, &d->nFP, par->maxFPixels,
		   x + y * par->fireW, par->maxPower );	    
      }
      fx += dx;
      fy += dy;
    }

    gr->x0 = x1;
    gr->y0 = y1;

    break;
  default:
  }

  return( 0 );
}
