#include "memutils.h"

#include <stdio.h>

void *allocMem( size_t size )
{
  void *ptr;

  ptr = malloc( size );

  if (!ptr) {
    fprintf( stderr, "Memory allocation failed!" );
    exit( 1 );
  }

  return( ptr );
}

void *reallocMem( void *ptr, size_t size )
{
  void *ptr2;

  ptr2 = realloc( ptr, size );

  if (!ptr2) {
    fprintf( stderr, "Memory reallocation failed!" );
    exit( 1 );
  }

  return( ptr2 );
}

void freeMem( void *ptr )
{
  if (ptr) free( ptr );
}
